\chapter*{Appendix 1}
\addcontentsline{toc}{chapter}{Appendix 1}

%changer le format des sections, subsections pour apparaittre sans le num de chapitre
\makeatletter
\renewcommand{\thesection}{\@arabic\c@section}
\makeatother

%recommencer la numérotation des section à "1"
\setcounter{section}{0}

\section*{The implementation of a custom Sampler}

The Pytorch library implements a class for the creation of a DataLoader\footnote{ The DataLoader manual can be consulted at this url: \url{https://pytorch.org/docs/stable/data.html}}: it combines a dataset and a sampler and provides an iterable over the given dataset. The custom sampler will be passed as the optional argument 'batch\_sampler'. The code for this custom sampler is the following. 

\begin{minted}[mathescape, linenos, breaklines=true]{python}
from typing import Sized, Tuple, List, Iterator
from torch.utils.data import Sampler
import random
import torch
import math


class EMIDECProportionateSampler(Sampler):
    """
    This sampler is to be used as a batch sampler.
    It returns batch that contains at least one positive case, 
    and that globally respect the proportions between the positive and negative cases.

        Args:
        data_source (sequence): the dataset, an EMIDEC Dataset to determine weither a patient is a positive or negative case
        batch_size (int): the size wanted for the batch
        
        Exception: 
        If the batch_size is equal to 1, raise an exception in order to be able to put both negative and postive cases in a batch
    """
    def __init__(
        self, data_source: Sized, 
        batch_size = 3,
        ):
        self.data_source = data_source
        self.positives = []
        self.negatives = []
        self.batch_size=batch_size
        self.indices=[]

        #Raise Exception
        if batch_size <= 1:
            raise ValueError(f"batch_size should be an integer greater than 1, but got batch_size={batch_size}")

        # Fill positives and negatives lists
        self._get_positives_and_negatives()
        
        # Get the number of positives and negatives for each batch 
        self.num_positives=min([batch_size-1,max([1,int(batch_size*(len(self.positives)/len(data_source))+0.5)])])
        self.num_negatives=batch_size-self.num_positives

    def _get_positives_and_negatives(self) -> None:
        for i in range(len(self.data_source)):
            if 'P' in self.data_source[i]['Case_ID']: 
                self.positives.append(i)
            else:
                self.negatives.append(i)

    def __iter__(self) -> Iterator[int]:
        #Shuffle the indices for both positives and negatives
        random.shuffle(self.positives)
        random.shuffle(self.negatives)
        
        i=0
        while (i+1)*self.num_negatives <= len(self.negatives) and (i+1)*self.num_positives <= len(self.positives):
            batch=[]
            batch += self.positives[i*self.num_positives : (i+1)*self.num_positives]
            batch += self.negatives[i*self.num_negatives : (i+1)*self.num_negatives]
            random.shuffle(batch)
            self.indices+=batch
            i+=1
        return iter(self.indices)

    def __len__(self) -> int:
        i=min(math.ceil(len(self.positives)/self.num_positives), math.ceil(len(self.negatives)/self.num_negatives))
        return(self.batch_size*(i-1))


\end{minted}
